#include "stdafx.h"
#include "consts.h"
#include "api.h"
#include "settings.h"

static HWND g_hwnd = NULL;
static int g_regular_w = 0;
static int g_regular_h = 0;

static void resize_apply(int size, bool first);

BOOL APIENTRY DllMain(HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved) {
	switch (ul_reason_for_call) {
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
	}
    return TRUE;
}

int __stdcall resize_init(int regular_w, int regular_h) {
	// p[^̕s`FbN
	if (regular_w <= 0 || regular_w > 8192 || regular_h <= 0 || regular_h > 8192) {
		return -1;  // p[^s
	}

	// ݒt@C
	resize_settings_init();

	// YEBhE
	HWND hwnd = ::FindWindow(L"RGSS Player", NULL);
	if (!hwnd) {
		return -2;  // RGSS Player
	}

	// ꂽEBhEw肳ꂽÕEBhEǂׂ
	wchar_t game_title[128];
	wchar_t wnd_title[128];
	resize_settings_get_title(game_title, sizeof(game_title));
	::GetWindowText(hwnd, wnd_title, sizeof(wnd_title));
	if (!wcsstr(wnd_title, game_title)) {
		return -3;  // Y閼ÕEBhEł͂Ȃ
	}

	// I
	g_hwnd = hwnd;
	g_regular_w = regular_w;
	g_regular_h = regular_h;

	// ߂̃TCY𕜌
	resize_apply(resize_get(), true);
	return 0;
}

int __stdcall resize_toggle(void) {
	// ς݂H
	if (!g_hwnd) {
		return -1;  // 
	}

	// EBhETCY؂ւ
	int size_next = resize_get() + 1;
	if (size_next > RESIZE_MAX) {
		size_next = RESIZE_MIN;
	}
	resize_apply(size_next, false);
	return 0;
}

int __stdcall resize_get(void) {
	// ς݂H
	if (!g_hwnd) {
		return RESIZE_REGULAR;  // 
	}

	// EBhETCY擾
	int size;
	resize_settings_get_wnd_size(&size);
	return size;
}

int __stdcall resize_set(int size) {
	// ς݂H
	if (!g_hwnd) {
		return -1;  // 
	}

	// EBhETCYݒ肷
	resize_apply(size, false);
	return 0;
}

void resize_apply(int size, bool first) {
	int x, y, cx, cy, cw, ch;
	int cx_screen = ::GetSystemMetrics(SM_CXSCREEN);
	int cy_screen = ::GetSystemMetrics(SM_CYSCREEN);
	int cy_title = ::GetSystemMetrics(SM_CYCAPTION);
	int cx_frame = ::GetSystemMetrics(SM_CXFIXEDFRAME);
	int cy_frame = ::GetSystemMetrics(SM_CYFIXEDFRAME);
	UINT flags;

	// EBhETCY̌
	if (size < RESIZE_MIN) {
		size = RESIZE_MIN;
	} else if (size > RESIZE_MAX) {
		size = RESIZE_MAX;
	}

	// SetWindowPos̃tOݒ肷
	flags = SWP_NOZORDER;
	flags |= ((size == RESIZE_REGULAR && first) ? SWP_NOMOVE : 0);

	// EBhE̊{TCY肷
	switch (size) {
		case RESIZE_REGULAR:  // {
			cw = g_regular_w;
			ch = g_regular_h;
			break;
		case RESIZE_LARGE:  // 1.5{
			cw = g_regular_w * 150 / 100;
			ch = g_regular_h * 150 / 100;
			break;
		case RESIZE_XLARGE:  // 2.0{
			cw = g_regular_w * 2;
			ch = g_regular_h * 2;
			break;
		default:  // ͂Ȃ
			return;
	}

	// ۂ̃TCYvZ
	cx = cw + (cx_frame * 2);
	cy = ch + (cy_frame * 2) + cy_title;

	// EBhËʒu肷
	x = (cx_screen - cx) / 2;
	y = (cy_screen - cy) / 2 - (cy_frame * 2 + cy_title);

	// EBhËʒuXV
	::SetWindowPos(g_hwnd, NULL, x, y, cx, cy, flags);

	// ύXTCYۑ
	resize_settings_set_wnd_size(size);
}